PROGRAM MAIN

  USE GLOBVAR
  USE LIKELIHOOD
  USE MATRIX

  IMPLICIT NONE
  
  INTEGER :: ind(N_boot+1),i,b,j,d,order(N_stat),temp
  REAL(8) :: stat(N_stat),store(N_boot+1,N_stat)
    
  DO i=1,N_bin-1
      thre(i) = 0.25d0*DBLE(i)
  END DO
  thre = thre*1000.0d0
  
  ! Compute test statistics using all markets
  N_en = 437
  N_market = 23
  ALLOCATE(dta2(N_en,N_col_en),dta0(N_market,T0),dta1(N_market,T1),F_j_ss(N_market,N_bin,N_bin,0:1),q_obs(N_market,N_bin,0:1),initial(N_market,0:1)) 
  OPEN(1,file="dta_all.out")
  DO i=1,N_en
      READ(1,fmt=*) dta2(i,:)
  END DO
  CLOSE(1)
  
  CALL initialize(0)  
  CALL frequency(0)
  stat = chi_squared(0)
  
  CALL Set_Seed(3923626,3923,797835,139646)
  store=0.0d0
  q_pool_store=q_pool
  p_pool_store=p_pool
  DO b = 1,N_boot
      q_pool=q_pool_store
      p_pool=p_pool_store
      CALL simulate_game(b)
      CALL frequency(0)
      store(b,:) = chi_squared(0)
  END DO
  store(N_boot+1,:) = stat
 
  DO i=1,N_stat
      DO b = 1,N_boot+1
          ind(b) = b
      END DO
      CALL sort(store(:,i),store(:,i),ind)
      DO b = 1,N_boot
          IF(store(b,i)==stat(i)) EXIT
      END DO
      order(i) = b
  END DO

  i = N_boot*0.95
  PRINT*, 'Test results: all markets (base result)'
  PRINT*, 'T_P, before'
  PRINT*, stat(3), store(i,3), 1.0d0-DBLE(order(3))/DBLE(N_boot+1)
  PRINT*, 'T_P, after'
  PRINT*, stat(4), store(i,4), 1.0d0-DBLE(order(4))/DBLE(N_boot+1)
  PRINT*, 'T_P*, before'
  PRINT*, stat(5), store(i,5), 1.0d0-DBLE(order(5))/DBLE(N_boot+1)
  PRINT*, 'T_P*, after'
  PRINT*, stat(6), store(i,6), 1.0d0-DBLE(order(6))/DBLE(N_boot+1)
  PRINT*, 'T_Q, before'
  PRINT*, stat(1), store(i,1), 1.0d0-DBLE(order(1))/DBLE(N_boot+1)
  PRINT*, 'T_Q, after'
  PRINT*, stat(2), store(i,2), 1.0d0-DBLE(order(2))/DBLE(N_boot+1)
  PRINT*, 'T_S, before'
  PRINT*, stat(7), store(i,7), 1.0d0-DBLE(order(7))/DBLE(N_boot+1)
  PRINT*, 'T_S, after'
  PRINT*, stat(8), store(i,8), 1.0d0-DBLE(order(8))/DBLE(N_boot+1)
  PRINT*, ''

  DEALLOCATE(dta2,dta0,dta1,F_j_ss,q_obs,initial) 

  
  ! Compute test statistics using small markets
  N_en = 133
  N_market = 7
  ALLOCATE(dta2(N_en,N_col_en),dta0(N_market,T0),dta1(N_market,T1),F_j_ss(N_market,N_bin,N_bin,0:1),q_obs(N_market,N_bin,0:1),initial(N_market,0:1)) 
  OPEN(1,file="dta_small.out")
  DO i=1,N_en
      READ(1,fmt=*) dta2(i,:)
  END DO
  CLOSE(1)
  
  CALL initialize(0)
  CALL frequency(0)
  stat = chi_squared(0)
  
  CALL Set_Seed(3923626,3923,797835,139646)
  store=0.0d0
  q_pool_store=q_pool
  p_pool_store=p_pool
  DO b = 1,N_boot
      q_pool=q_pool_store
      p_pool=p_pool_store
      CALL simulate_game(b)
      CALL frequency(0)
      store(b,:) = chi_squared(0)
  END DO
  store(N_boot+1,:) = stat
 
  DO i=1,N_stat
      DO b = 1,N_boot+1
          ind(b) = b
      END DO
      CALL sort(store(:,i),store(:,i),ind)
      DO b = 1,N_boot
          IF(store(b,i)==stat(i)) EXIT
      END DO
      order(i) = b
  END DO
  i = N_boot*0.95
  PRINT*, 'Test results: small markets'
  PRINT*, 'T_P, before'
  PRINT*, stat(3), store(i,3), 1.0d0-DBLE(order(3))/DBLE(N_boot+1)
  PRINT*, 'T_P, after'
  PRINT*, stat(4), store(i,4), 1.0d0-DBLE(order(4))/DBLE(N_boot+1)
  PRINT*, 'T_P*, before'
  PRINT*, stat(5), store(i,5), 1.0d0-DBLE(order(5))/DBLE(N_boot+1)
  PRINT*, 'T_P*, after'
  PRINT*, stat(6), store(i,6), 1.0d0-DBLE(order(6))/DBLE(N_boot+1)
  PRINT*, ''
  
  DEALLOCATE(dta2,dta0,dta1,F_j_ss,q_obs,initial) 

  
  ! Compute test statistics using medium markets  
  N_en = 152
  N_market = 8
  ALLOCATE(dta2(N_en,N_col_en),dta0(N_market,T0),dta1(N_market,T1),F_j_ss(N_market,N_bin,N_bin,0:1),q_obs(N_market,N_bin,0:1),initial(N_market,0:1)) 
  OPEN(1,file="dta_medium.out")
  DO i=1,N_en
      READ(1,fmt=*) dta2(i,:)
  END DO
  CLOSE(1)
  
  CALL initialize(0)
  CALL frequency(0)
  stat = chi_squared(0)
  
  CALL Set_Seed(3923626,3923,797835,139646)
  store=0.0d0
  q_pool_store=q_pool
  p_pool_store=p_pool
  DO b = 1,N_boot
      q_pool=q_pool_store
      p_pool=p_pool_store
      CALL simulate_game(b)
      CALL frequency(0)
      store(b,:) = chi_squared(0)
  END DO
  store(N_boot+1,:) = stat
 
  DO i=1,N_stat
      DO b = 1,N_boot+1
          ind(b) = b
      END DO
      CALL sort(store(:,i),store(:,i),ind)
      DO b = 1,N_boot
          IF(store(b,i)==stat(i)) EXIT
      END DO
      order(i) = b
  END DO
  i = N_boot*0.95
  PRINT*, 'Test results: medium markets'
  PRINT*, 'T_P, before'
  PRINT*, stat(3), store(i,3), 1.0d0-DBLE(order(3))/DBLE(N_boot+1)
  PRINT*, 'T_P, after'
  PRINT*, stat(4), store(i,4), 1.0d0-DBLE(order(4))/DBLE(N_boot+1)
  PRINT*, 'T_P*, before'
  PRINT*, stat(5), store(i,5), 1.0d0-DBLE(order(5))/DBLE(N_boot+1)
  PRINT*, 'T_P*, after'
  PRINT*, stat(6), store(i,6), 1.0d0-DBLE(order(6))/DBLE(N_boot+1)
  PRINT*, ''

  
  ! Compute test statistics using large markets  
  OPEN(1,file="dta_large.out")
  DO i=1,N_en
      READ(1,fmt=*) dta2(i,:)
  END DO
  CLOSE(1)
  
  CALL initialize(0)
  CALL frequency(0)
  stat = chi_squared(0)
  
  CALL Set_Seed(3923626,3923,797835,139646)
  store=0.0d0
  q_pool_store=q_pool
  p_pool_store=p_pool
  DO b = 1,N_boot
      q_pool=q_pool_store
      p_pool=p_pool_store
      CALL simulate_game(b)
      CALL frequency(0)
      store(b,:) = chi_squared(0)
  END DO
  store(N_boot+1,:) = stat
 
  DO i=1,N_stat
      DO b = 1,N_boot+1
          ind(b) = b
      END DO
      CALL sort(store(:,i),store(:,i),ind)
      DO b = 1,N_boot
          IF(store(b,i)==stat(i)) EXIT
      END DO
      order(i) = b
  END DO
  i = N_boot*0.95
  PRINT*, 'Test results: large markets'
  PRINT*, 'T_P, before'
  PRINT*, stat(3), store(i,3), 1.0d0-DBLE(order(3))/DBLE(N_boot+1)
  PRINT*, 'T_P, after'
  PRINT*, stat(4), store(i,4), 1.0d0-DBLE(order(4))/DBLE(N_boot+1)
  PRINT*, 'T_P*, before'
  PRINT*, stat(5), store(i,5), 1.0d0-DBLE(order(5))/DBLE(N_boot+1)
  PRINT*, 'T_P*, after'
  PRINT*, stat(6), store(i,6), 1.0d0-DBLE(order(6))/DBLE(N_boot+1)
  PRINT*, ''
  
  DEALLOCATE(dta2,dta0,dta1,F_j_ss,q_obs,initial) 

  END PROGRAM MAIN



