PROGRAM MAIN

  USE GLOBVAR
  USE LIKELIHOOD
  USE MATRIX

  IMPLICIT NONE
  
  INTEGER :: ind(N_boot+1),i,b,j,d,order(N_stat)
  REAL(8) :: stat(N_stat),store(N_boot+1,N_stat),temp
  
  DO i=1,N_bin-1
      thre(i) = 0.25d0*DBLE(i)
  END DO
  thre = thre*1000.0d0
  
  N_en = 437
  N_market = 23
  ALLOCATE(dta0(N_market,T0),dta1(N_market,T1),initial(N_market,0:1),dta2(N_en,N_col_en),q_obs(N_market,N_bin,0:1),F_j_ss(N_market,N_bin,N_bin,0:1),P_j(N_market,N_bin,N_bin,0:1))  
  OPEN(1,file="dta_all.out")
  DO i=1,N_en
      READ(1,fmt=*) dta2(i,:)
  END DO
  CLOSE(1)
  
  CALL initialize(0)
  CALL frequency(0)
  stat = chi_squared(0)
  
  CALL Set_Seed(3923626,3923,797835,139646)
  store=0.0d0

  q_pool_store=q_pool
  p_pool_store=p_pool
  DO b = 1,N_boot
      q_pool=q_pool_store
      p_pool=p_pool_store
      CALL simulate_game(b)
      CALL frequency(0)
      store(b,:) = chi_squared(0)
  END DO
  store(N_boot+1,:) = stat
 
  DO i=1,N_stat
      DO b = 1,N_boot+1
          ind(b) = b
      END DO
      CALL sort(store(:,i),store(:,i),ind)
      DO b = 1,N_boot
          IF(store(b,i)==stat(i)) EXIT
      END DO
      order(i) = b
  END DO

  i = N_boot*0.95
  PRINT*, 'Test results: accounting for unobserved types'
  PRINT*, 'T_S_tilda, before'
  PRINT*, stat(1), store(i,1), 1.0d0-DBLE(order(1))/DBLE(N_boot+1)
  PRINT*, 'T_S_tilda, after'
  PRINT*, stat(2), store(i,2), 1.0d0-DBLE(order(2))/DBLE(N_boot+1)
  PRINT*, 'T_P_tilda, before'
  PRINT*, stat(3), store(i,3), 1.0d0-DBLE(order(3))/DBLE(N_boot+1)
  PRINT*, 'T_P_tilda, after'
  PRINT*, stat(4), store(i,4), 1.0d0-DBLE(order(4))/DBLE(N_boot+1)  
  PRINT*, ''
  DEALLOCATE(dta0,dta1,initial,dta2,q_obs,F_j_ss,P_j)  
  
  N_en = 152
  N_market = 8
  ALLOCATE(dta0(N_market,T0),dta1(N_market,T1),initial(N_market,0:1),dta2(N_en,N_col_en),q_obs(N_market,N_bin,0:1),F_j_ss(N_market,N_bin,N_bin,0:1),P_j(N_market,N_bin,N_bin,0:1))  
  OPEN(1,file="dta_large.out")
  DO i=1,N_en
      READ(1,fmt=*) dta2(i,:)
  END DO
  CLOSE(1)
  
  CALL initialize(0)
  CALL frequency(0)
  stat = chi_squared(0)
  
  CALL Set_Seed(3923626,3923,797835,139646)
  store=0.0d0

  q_pool_store=q_pool
  p_pool_store=p_pool
  DO b = 1,N_boot
      q_pool=q_pool_store
      p_pool=p_pool_store
      CALL simulate_game(b)
      CALL frequency(0)
      store(b,:) = chi_squared(0)
  END DO
  store(N_boot+1,:) = stat
 
  DO i=1,N_stat
      DO b = 1,N_boot+1
          ind(b) = b
      END DO
      CALL sort(store(:,i),store(:,i),ind)
      DO b = 1,N_boot
          IF(store(b,i)==stat(i)) EXIT
      END DO
      order(i) = b
  END DO

  i = N_boot*0.95
  PRINT*, 'Test results: accounting for unobserved types, large markets'
  PRINT*, 'T_S_tilda, before'
  PRINT*, stat(1), store(i,1), 1.0d0-DBLE(order(1))/DBLE(N_boot+1)
  PRINT*, 'T_S_tilda, after'
  PRINT*, stat(2), store(i,2), 1.0d0-DBLE(order(2))/DBLE(N_boot+1)
  PRINT*, 'T_P_tilda, before'
  PRINT*, stat(3), store(i,3), 1.0d0-DBLE(order(3))/DBLE(N_boot+1)
  PRINT*, 'T_P_tilda, after'
  PRINT*, stat(4), store(i,4), 1.0d0-DBLE(order(4))/DBLE(N_boot+1)  
  DEALLOCATE(dta0,dta1,initial,dta2,q_obs,F_j_ss,P_j)  
  
  
END PROGRAM MAIN



