PROGRAM MAIN

  USE GLOBVAR
  USE LIKELIHOOD
  USE RANDOM
  USE MATRIX

  IMPLICIT NONE
  
  INTEGER :: i,j,k,m,t,b,bb(N_stat),s1,s2,a1,a2,ind(N_boot),s,ss,sss,ssss,cc
  REAL(8) :: u,u1,u2,pro(2,2,4),lambda_v(4),test(N_boot,N_stat),temp,store(N_sim,3,N_stat)
  
  pro(1,1,:) = (/0.73d0,0.61d0,0.80d0,0.75d0/)
  pro(2,1,:) = (/0.62d0,0.31d0,0.83d0,0.61d0/)
  pro(1,2,:) = (/0.28d0,0.42d0,0.22d0,0.29d0/)
  pro(2,2,:) = (/0.53d0,0.84d0,0.30d0,0.58d0/)  
  lambda_v=(/1.0d0,0.0d0,0.5d0,0.9d0/)
  
  ! Set initial=1 if initial condition is also simulated in bootstrap (use this for Tp, Tp*, and TQ) and initial=2 if initial condition is the same as the data (use this for Ts)
  initial=1
  
  OPEN(514,file="test.out")  
  DO ssss=1,6
      N_mar = 20*2**(ssss-1)
      DO sss=1,8
          N_time= 5*2**(sss-1)
          ALLOCATE(dta(N_mar,0:N_time),Qs_j(N_mar,4),sigma_j(N_mar,4,4),dta_ccp(N_mar,4,4),fj_as(N_mar,4,4),fj_s(N_mar,4),fj_s_dta(N_mar,4),Qsst(4,4,N_time),iotaP(4,4,N_time))
          DO ss=1,4
              lambda = lambda_v(ss)
              
              ! Generate data, estimate probabilities, and bootstrap
              DO s=1,N_sim
                  CALL Set_Seed(407286+s,89*s,2598626-s*20,14966+2*s)  
                  
                  ! Generate path of states
                  dta=0  
                  DO m = 1,N_mar
                      IF(m<=lambda*N_mar) THEN
                          k=1
                      ELSE
                          k=2
                      END IF
                      s1=0
                      s2=0
                      DO t = 1,Sno+N_time      
                          a1=0
                          a2=0
                          u1 = Sample_Uniform(0.0d0,1.0d0)
                          u2 = Sample_Uniform(0.0d0,1.0d0)
                          IF(u1<pro(k,1,s1*2+s2+1)) a1=1
                          IF(u2<pro(k,2,s1*2+s2+1)) a2=1
                          IF(t>=Sno) THEN
                              dta(m,t-Sno) = a1*2+a2+1
                          END IF
                          s1=a1
                          s2=a2
                      END DO
                  END DO

                  ! dta_ccp
                  DO m=1,N_mar
                      DO s1=1,4
                          DO s2=1,4
                              cc=0
                              DO t=1,N_time
                                  IF(dta(m,t-1)==s1 .AND. dta(m,t)==s2) cc=cc+1
                              END DO
                              dta_ccp(m,s1,s2) = DBLE(cc)
                          END DO
                      END DO
                  END DO
                  
                  ! Calculate CCP, Qs, and etc
                  CALL frequency(0)
                  store(s,1,1:N_stat) = test_stat(0)
                   
                  ! Bootstrap and store data                  
                  sigma_store = sigma
                  DO b=1,N_boot
                      sigma = sigma_store
                      CALL boot(sigma)
                      CALL frequency(0)
                      test(b,1:N_stat) = test_stat(0)
                  END DO
                  i = (N_boot+1)*0.5d0
                  j = (N_boot+1)*0.95d0
                  DO b=1,N_stat
                      CALL Sort(test(:,b),test(:,b),ind)
                      store(s,2,b) = test(i,b)
                      store(s,3,b) = test(j,b)
                  END DO     
              END DO
                            
              ! Calculate the share of rejection
              bb=0
              DO j=1,N_stat
                  DO i=1,N_sim
                      IF(store(i,1,j)>store(i,3,j)) bb(j)=bb(j)+1
                  END DO
              END DO
              print*,  bb(1:4)
              WRITE(514,'(3I,<N_stat*4>F16.8)') N_mar,N_time,ss,DBLE(bb)/DBLE(N_sim)
          END DO
          DEALLOCATE(dta,Qs_j,sigma_j,dta_ccp,fj_as,fj_s,fj_s_dta,Qsst,iotaP)
      END DO
      print*, ''
  END DO
  CLOSE(514)
  
END PROGRAM main
